/*
 * Created on 2005.6.17
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 * 
 * ---- NOTES ----
 * - Each account is uniquely identified by its username (I also used int ID in previous versions,
 *   but since all usernames must be unique, we don't need another unique identifier).
 */

/**
 * @author Betalord
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Account {

	/*
	 *
	 * access levels (first 3 bits of int access):
	 * 0 - none (should not be used for logged-in clients)
	 * 1 - normal (limited)
	 * 2 - privileged
	 * 3 - admin 
	 * 4, 5, 6, 7 - "reserved for future use"
	 * 
	 * all other bits are unused ("reserver for future use")
	 * 
	 */
	
	String user;
	String pass;
	int access; // access type. Bit 31 must be 0 (due to int being signed number - we don't want to use any binary complement conversions). Bits 30-28 are access level.
	
	public Account(String user, String pass, int access)
	{
		this.user = user;
		this.pass = pass;
		this.access = access;
	}
	
	public Account(Account acc) {
		this.user = new String(acc.user);
		this.pass = new String(acc.pass);
		this.access = acc.access;
	}
	
	public String toString() {
		return user + " " + pass + " " + Integer.toString(access, 2); 
	}
	
	public int accessLevel() {
		return access & 0x7;
	}
	
	/* returns access as normal (non-admin) user would have */
	public static int getNormalAccess() {
		return 1;
	}
	
	public static int getPrivilegedAccess() {
		return 2;
	}
		
	public static int getAdminAccess() {
		return 3;
	}
	
}
